; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
;	INPUT:	TEMP1 (X1)	(0...127)												
;			TEMP2 (Y1)	(0...63)												
;			TEMP3 (X2)	(0...127)												
;			TEMP4 (Y2)	(0...63)												
;																				
;	rcall LCD_LINE	; INP: TEMP1+2   TEMP3+4									
;																				
LCD_LINE:
	push temp1          ; auf dem Stack sichern            			
	push temp2
	push temp3
	push temp4
	push temp5
	push temp6
	push temp7
	push temp8
	push temp9
;--------------------------
	; PRFUNG, Anfang+Ende gleich			; nur einen einzigen Punkt setzen	
	cp temp1,temp3		; X
	brne LCD_LINE_ANF_ENDE_w
	cp temp2,temp4		; Y
	brne LCD_LINE_ANF_ENDE_w
	rcall LCD_PUNKT		; INP: TEMP1+2
	rjmp LCD_LINE_FERIG
;--------------------------
LCD_LINE_ANF_ENDE_w:
	; ANFANGS-PUNKT setzen				
	rcall LCD_PUNKT		; INP: TEMP1+2
	; END-PUNKT setzen					
	push temp1			; sichern		
	push temp2
	mov temp1,temp3
	mov temp2,temp4
	rcall LCD_PUNKT		; INP: TEMP1+2
	pop temp2			; wieder herstellen
	pop temp1
;--------------------------
	; Y1=Y2 nur Waagerechte Linien	
	cp temp2,temp4	
	brne LCD_LINE_WAAGE_FERTIG
	; SORTIEREN X1<=X2					
	cp temp1,temp3	
	brlo LCD_LINE_WAAGE_SCHLEIFE
	push temp1
	push temp3
	pop  temp1
	pop  temp3
LCD_LINE_WAAGE_SCHLEIFE:
	inc temp1
	rcall LCD_PUNKT		; INP: TEMP1+2
	cp temp1,temp3
	brne LCD_LINE_WAAGE_SCHLEIFE
	rjmp LCD_LINE_FERIG
LCD_LINE_WAAGE_FERTIG:
;--------------------------
	; X1=X2 nur SENKRECHTE Linien	
	cp temp1,temp3	
	brne LCD_LINE_SENKRECHT_FERTIG
	; sortieren Y1<Y2				
	cp temp2,temp4
	brlo LCD_LINE_SENKRECHT_SCHLEIFE
	push temp2
	push temp4
	pop  temp2
	pop  temp4
LCD_LINE_SENKRECHT_SCHLEIFE:
	inc temp2
	rcall LCD_PUNKT		; INP: TEMP1+2
	cp temp2,temp4
	brne LCD_LINE_SENKRECHT_SCHLEIFE
	rjmp LCD_LINE_FERIG
LCD_LINE_SENKRECHT_FERTIG:
;---------------------------------------
	; SCHRGE LINIEN y= ax + b			
	; SORTIEREN X1<=X2					
	cp temp1,temp3	
	brlo LCD_LINE_SCHRAEG_w1
	push temp1
	push temp2
	push temp3
	push temp4
	pop  temp2
	pop  temp1
	pop  temp4
	pop  temp3
LCD_LINE_SCHRAEG_w1:
	; ANFANG und ENDE in SRAM speichern		
	STS (adr_LCD_X1),temp1			; X1
	STS (adr_LCD_Y1),temp2			; Y1
	STS (adr_LCD_X2),temp3			; X2
	STS (adr_LCD_Y2),temp4			; Y2
	; Verschiebung in SRAM SPEICHERN		
	STS (adr_VERSCHIEBUNG_X),temp1	; X1
	STS (adr_VERSCHIEBUNG_Y),temp2	; Y1
	; DELTA X berechnen		
	SUB temp3,temp1
	STS(adr_LCD_DELTA_X),temp3
	; DELTA Y berechnen		
	clr temp
	STS (adr_ANSTIEG_NEGATIV),temp	; auf positiv ANSIEG setzen	
	cp  temp4,temp2
	brsh LCD_LINE_Y_w1
	push temp2						; Register tauschen		
	push temp4
	pop  temp2
	pop  temp4
	ldi  temp,1
	STS (adr_ANSTIEG_NEGATIV),temp	; auf negativ ANSIEG setzen	
LCD_LINE_Y_w1:	
	SUB temp4,temp2
	STS(adr_LCD_DELTA_Y),temp4
;---------------------------------
	; 	X1 und Y1 nach X Y  ALT	  
	LDS temp1,(adr_LCD_X1)
	STS (adr_LCD_X_alt),temp1		; X1
	LDS temp2,(adr_LCD_Y1)
	STS (adr_LCD_Y_alt),temp2		; Y1

	; zuweisen fr SCHLEIFE	
	LDS temp6, (adr_LCD_X1)		; HAUPT-ZHLER(START) X1
	LDS temp7, (adr_LCD_X2)		; HAUPT-ZHLER(STOP)  X2
	STS (adr_LCD_X_neu),temp6	; X-neu		
	clr temp
	STS (adr_ZAEHLER_X),temp	; ZWISCHEN-ZHLER-X		



LCD_LINE_SCHRAEG_SCHLEIFE:
	LDS temp,(adr_ZAEHLER_X)	; ZWISCHEN-ZHLER-X	(laden)		
	inc temp
	STS (adr_ZAEHLER_X),temp	; ZWISCHEN-ZHLER-X	(speichern)	
	inc temp6					; HAUPT-ZHLER X +1			
	STS (adr_LCD_X_neu),temp6	; X-neu						

	; neuen Y-Wert berechnen 
	rcall LCD_LINE_Y_BERECHNUNG	; INPUT: SRAM	


	; ZEICHNEN 
	LDS temp1,(adr_LCD_X_neu)
	LDS temp2,(adr_LCD_Y_neu)
	rcall LCD_PUNKT				; INP: TEMP1+2				

	cp temp6,temp7				; VERGLEICH HAUPT-ZHLER X (START-STOP)	
	brne LCD_LINE_SCHRAEG_SCHLEIFE
	rjmp LCD_LINE_FERIG





;------------
LCD_LINE_FERIG:
	pop temp9
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp4			; Sicherungskopie wieder laden				
	pop temp3
	pop temp2
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_LINE_Y_BERECHNUNG:
	push temp
	push temp1
	push temp2
	push temp3
	push temp4
	push temp5
	push temp6
	push temp7
	push temp8
	push temp9
;---------------------------------------

	LDS temp1,(adr_ZAEHLER_X)		; ZWISCHEN-ZHLER-X	(laden)		
	LDS temp2,(adr_LCD_DELTA_Y) 	; DELTA-Y (laden)				


	; MULTIPLIZIEREN			
	mul temp1,temp2					; Ergebnis in R0+R1

	; DIVISION mit RUNDUNG		
	mov temp1,R0
	mov temp2,R1
	clr temp3
	clr temp4
	LDS temp5,(adr_LCD_DELTA_X) 	; DELTA-X (laden)				
	rcall FUNKTION_DIVISION_32_8	; INP:TEMP1...4 TEMP5(DIVISOR) / OUT: temp1...4
	STS (adr_LCD_Y_neu),temp1
	
	; PRFUNG ANSTIEG POSITIV/negativ	
	LDS temp,(adr_ANSTIEG_NEGATIV)
	tst temp
	breq LCD_LINE_Y_ADDIEREN_POSITIV
	; Y-VERSCHIEBUNG addieren (negativer ANSTIEG)	
	LDS temp1,(adr_VERSCHIEBUNG_Y)
	LDS temp2,(adr_LCD_Y_neu)
	sub temp1,temp2
	STS (adr_LCD_Y_neu),temp1
	rjmp LCD_LINE_Y_ADDIEREN_FERTIG
LCD_LINE_Y_ADDIEREN_POSITIV:
	; Y-VERSCHIEBUNG addieren (positiver ANSTIEG)	
	LDS temp1,(adr_VERSCHIEBUNG_Y)
	LDS temp2,(adr_LCD_Y_neu)
	add temp1,temp2
	STS (adr_LCD_Y_neu),temp1
LCD_LINE_Y_ADDIEREN_FERTIG:
	; Y ZWISCHENPUNKTE setzen (LCKENFLLER)
	rcall LCD_LINE_Y_LUECKEN_FUELLER


;---------------------------------------
LCD_LINE_Y_BERECHNUNG_FERTIG:
	pop temp9
	pop temp8
	pop temp7
	pop temp6
	pop temp5
	pop temp4
	pop temp3
	pop temp2
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_LINE_Y_LUECKEN_FUELLER:
	; alten und neuen Y-WERT laden
	LDS temp1,(adr_LCD_Y_alt)
	LDS temp2,(adr_LCD_Y_neu)
	; wer ist grsser			
	cp temp1,temp2
	brsh LCD_LINE_Y_LUECKEN_FUELLER_w
	; REGISTER TAUSCHEN					
	push temp1
	push temp2
	pop  temp1
	pop  temp2
LCD_LINE_Y_LUECKEN_FUELLER_w:
	; DIFFERENZ bilden (ALTER-NEUER Y WERT)	
	sub temp1,temp2
	; DIFFERENZ grsser gleich 2 ?	
	cpi temp1,2
	brsh LCD_LINE_Y_LUECKEN_FUELLER_START
	ret
LCD_LINE_Y_LUECKEN_FUELLER_START:
	; DIFFERENZ gleich 2 (1 LOCH)	
	cpi temp1,2
	brne LCD_LINE_Y_LUECKEN_FUELLER_DIFF_w
	; PRFUNG ANSTIEG POSITIV/negativ	
	LDS temp,(adr_ANSTIEG_NEGATIV)
	tst temp
	brne LCD_LINE_Y_LUECKEN_FUELLER_1_LOCH_n 	
	; 1 "Loch" fllen fr positiv	
	LDS temp1,(adr_LCD_X_alt)
	LDS temp2,(adr_LCD_Y_alt)
	inc temp2		; Y+1
	rcall LCD_PUNKT	; INP: TEMP1+2 
	ret
LCD_LINE_Y_LUECKEN_FUELLER_1_LOCH_n:
	; 1 "Loch" fllen fr negativ	
	LDS temp1,(adr_LCD_X_alt)
	LDS temp2,(adr_LCD_Y_alt)
	dec temp2		; Y-1
	rcall LCD_PUNKT	; INP: TEMP1+2 
	ret
LCD_LINE_Y_LUECKEN_FUELLER_DIFF_w:
	; DIFFERENZ-Wert spalten		
	mov temp2,temp1	
	LSR temp2			; WERT durch 2		
	SUB temp1,temp2
	mov temp3,temp1		; fr SCHLEIFE 1	
	mov temp4,temp2 	; fr Schleife2		
	; die vorher gezeichneten Punkt-Koordinaten laden
	LDS temp1,(adr_LCD_X_alt)
	LDS temp2,(adr_LCD_Y_alt)
	; PRFUNG ANSTIEG POSITIV/negativ	
	LDS temp,(adr_ANSTIEG_NEGATIV)
	tst temp
	brne LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_NEGATIV_1
	; SCHLEIFE 1 positiver ANSTIEG 
LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_POSITIV_1:
	inc temp2		; Y+1
	rcall LCD_PUNKT	; INP: TEMP1+2 
	dec temp3
	brne LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_POSITIV_1
	; SCHLEIFE 2 positiver ANSTIEG 
	inc temp1		; X+1
LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_POSITIV_2:
	inc temp2		; Y+1
	rcall LCD_PUNKT	; INP: TEMP1+2 
	dec temp4
	brne LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_POSITIV_2
	ret
;------------------------------------------------
	; SCHLEIFE 1 negativer ANSTIEG 
LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_NEGATIV_1:
	dec temp2
	rcall LCD_PUNKT	; INP: TEMP1+2 
	dec temp3
	brne LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_NEGATIV_1
	; SCHLEIFE 2 positiver ANSTIEG 
	inc temp1		; X+1
LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_NEGATIV_2:
	dec temp2
	rcall LCD_PUNKT	; INP: TEMP1+2 
	dec temp4
	brne LCD_LINE_Y_LUECKEN_FUELLER_SCHLEIFE_NEGATIV_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
