; ##############################################################################
; ##############################################################################
; ##############################################################################
; Diese Routine stellt ein ASCII-Zeichen auf dem Display dar.					
; INP: temp	(0...127 ASCII, 128...255 inverses ASCII							
ASCII_TEMP:
	push temp
	push temp1
	push temp8
	push temp9
	push XL
	push XH
	push ZL
	push ZH
;-------------------------------------------------------------------------------
	; ASCII invers ?				
	SBRC temp,7					
	STS(adr_GRAFIC_FARBE),EINS
	andi temp,0b01111111
	; ASCII invers darstellen ?				
	LDS temp8,(adr_GRAFIC_FARBE)
;-------------------------------------------------------------------------------
	; FONT-TABELLE Z initialisieren			
	ldi ZH, high(FONT*2)
	ldi ZL,  low(FONT*2)
	ldi temp1,48
	andi temp,0b01111111	; 0...127
	MUL temp,temp1
	add ZL,R0
	adc ZH,R1
;-------------------------------------------------------------------------------
	; CURSOR laden X (ZEILE)				
	LDS XL,(adr_GRAFIC_CURSOR_L)
	LDS XH,(adr_GRAFIC_CURSOR_H)
;-------------------------------------------------------------------------------
	; BERLAUF ?							
	cpi XH, HIGH(adr_TV_BILDBEREICH_ENDE+1)
	brlo ASCII_TEMP_RUN
	breq ASCII_TEMP_LOW
	rjmp ASCII_TEMP_ERROR
ASCII_TEMP_LOW:
	cpi XL, LOW(adr_TV_BILDBEREICH_ENDE+1)
	brlo ASCII_TEMP_RUN
	breq ASCII_TEMP_RUN
	rjmp ASCII_TEMP_ERROR
ASCII_TEMP_ERROR:
	; ERROR									
	ldi XL, LOW (adr_TV_BILDBEREICH+40*23)	; Zeile	1
	ldi XH, HIGH(adr_TV_BILDBEREICH+40*23)
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
ASCII_TEMP_RUN:
;-------------------------------------------------------------------------------
	; ASCII aus TABELLE holen				
	ldi temp9,24
ASCII_TEMP_s1:
	LPM temp, Z+   					; aus Tabelle laden	
	rcall FUNCTION_BITUMKEHR_TEMP	; BIT-TAUSCH		
	push temp						; sichern			
	LPM temp, Z+   					; aus Tabelle laden	
	rcall FUNCTION_BITUMKEHR_TEMP	; BIT-TAUSCH		
	push temp						; sichern			
	dec temp9
	brne ASCII_TEMP_s1
;-------------------------------------------------------------------------------
	; ASCII write (von unten nach oben)		
	ldi temp9,24
ASCII_TEMP_s2:
	pop temp						; wiederherstellen (HIGH)		
	SBRC temp8,0					; ASCII invers ?				
	com temp						; invertieren					
	ST X+,temp						; in BILDSPEICHER speichern	X+1	
	pop temp						; wiederherstellen (LOW)		
	SBRC temp8,0					; ASCII invers ?				
	com temp						; invertieren					
	ST X+,temp						; in BILDSPEICHER speichern	X+1	
	SBIW XL,42						; SRAM-ADRESSE auf nchste ZEILE
	dec temp9
	brne ASCII_TEMP_s2
;-------------------------------------------------------------------------------
	; CURSOR SPALTE							
	LDS XL,(adr_GRAFIC_CURSOR_L)
	LDS XH,(adr_GRAFIC_CURSOR_H)
	; CURSOR-SPALTENZHLER					
	LDS temp,(adr_GRAFIC_CURSOR_SPALTE)
	inc temp
	STS(adr_GRAFIC_CURSOR_SPALTE),temp
	cpi temp,20
	breq ASCII_TEMP_NEW_ZEILE
	adiw XL,2
	rjmp ASCII_TEMP_FERTIG
;-------------------------------------------------------------------------------
ASCII_TEMP_NEW_ZEILE:
	; CURSOR auf neue ZEILE					
	STS(adr_GRAFIC_CURSOR_SPALTE),NULL
	ldi temp ,LOW (960+2-40)
	ldi temp1,HIGH(960+2-40)
	add XL,temp
	adc XH,temp1
;-------------------------------------------------------------------------------
ASCII_TEMP_FERTIG:
	; CURSOR save X (ZEILE)				
	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop ZH
	pop ZL
	pop XH
	pop XL
	pop temp9
	pop temp8
	pop temp1
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ASCII_TEXT_w
	ret
ASCII_TEXT_w:
	rcall ASCII_TEMP			; Anzeige
	rjmp ASCII_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_CURSOR_ZEILE_1:
	push temp
	ldi temp,1
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_2:
	push temp
	ldi temp,2
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_3:
	push temp
	ldi temp,3
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_4:
	push temp
	ldi temp,4
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_5:
	push temp
	ldi temp,5
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_6:
	push temp
	ldi temp,6
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_7:
	push temp
	ldi temp,7
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_8:
	push temp
	ldi temp,8
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_9:
	push temp
	ldi temp,9
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_10:
	push temp
	ldi temp,10
	rjmp ASCII_CURSOR_ZEILE_TEMP
;-------------------------------------------------------------------------------
ASCII_CURSOR_ZEILE_TEMP:
	push XL
	push XH
	push YL
	push YH

	STS(adr_GRAFIC_CURSOR_SPALTE),NULL

	ldi XL, LOW (adr_TV_BILDBEREICH+40*23)	; Zeile	1
	ldi XH, HIGH(adr_TV_BILDBEREICH+40*23)

	dec temp
	tst temp
	breq GRAFIC_CURSOR_ZEILE__ENDE

	ldi XL,  LOW(960)
	ldi XH, HIGH(960)
	clr YL
	clr YH
GRAFIC_CURSOR_ZEILE_s:
	add YL,XL
	adc YH,XH
	dec temp
	brne GRAFIC_CURSOR_ZEILE_s

	ldi XL, LOW (adr_TV_BILDBEREICH+40*23)	; Zeile	1
	ldi XH, HIGH(adr_TV_BILDBEREICH+40*23)
	add XL,YL
	adc XH,YH
GRAFIC_CURSOR_ZEILE__ENDE:


	STS(adr_GRAFIC_CURSOR_L),XL
	STS(adr_GRAFIC_CURSOR_H),XH
	pop YH
	pop YL
	pop XH
	pop XL
	pop temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ASCII_SPACE5:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE4:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE3:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE2:
	ldi temp,' '
	rcall ASCII_TEMP
ASCII_SPACE:
	ldi temp,' '
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_PUNKT:
	ldi temp,'.'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_DOPPEL_PUNKT:
	ldi temp,':'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_PLUS:
	ldi temp,'+'
	rjmp ASCII_TEMP
; ##############################################################################
ASCII_MINUS:
	ldi temp,'-'
	rjmp ASCII_TEMP
; ##############################################################################

