; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
FUNCTION_ZUFALLSZAHL_TEMP:
	push temp1
	clr ZL
	clr ZH
FUNCTION_ZUFALLSZAHL_TEMP_s:
	LD temp1,Z+
	add temp,temp1
	cpi ZH,HIGH(1000)
	brne FUNCTION_ZUFALLSZAHL_TEMP_s
	cpi ZL,LOW (1000)
	brne FUNCTION_ZUFALLSZAHL_TEMP_s
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
; 0b00000001 --> 0b10000000														
FUNCTION_BITUMKEHR_TEMP:
	cpi temp,255
	brne FUNCTION_BITUMKEHR_TEMP_w
	ret
FUNCTION_BITUMKEHR_TEMP_w:
	tst temp
	brne FUNCTION_BITUMKEHR_TEMP_RUN
	ret
FUNCTION_BITUMKEHR_TEMP_RUN:
	push temp1
	push temp9
	ldi temp9,8	
FUNCTION_BITTAUSCH_TEMP_s:
	LSR temp	; 1xrechts			
	ROL	temp1	; 1xlinks ber CARRY
	dec temp9
	brne FUNCTION_BITTAUSCH_TEMP_s
	mov temp,temp1
	pop temp9
	pop temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
FUNCTION_360_GRD_CHECK_TEMP1_TEMP2:
	cpi temp2,HIGH(3600)
	breq FUNCTION_360_GRD_CHECK_TEMP1_TEMP2_L
	brsh FUNCTION_360_GRD_CHECK_TEMP1_TEMP2_ERROR
	ret
FUNCTION_360_GRD_CHECK_TEMP1_TEMP2_L:
	cpi temp1,LOW (3600)
	brsh FUNCTION_360_GRD_CHECK_TEMP1_TEMP2_ERROR
	ret
FUNCTION_360_GRD_CHECK_TEMP1_TEMP2_ERROR:
	subi temp1,LOW (3600)	; 360 GRD subtrahieren	
	SBCI temp2,HIGH(3600)	
	rjmp FUNCTION_360_GRD_CHECK_TEMP1_TEMP2
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
; INP: temp1(LOW),temp2(HIGH)	(WINKEL   0...360)								
; OUT: temp1(LOW),temp2(HIGH) 	(WERT  -127...+127)								
FUNCTION_SINUS_16_TEMP1_TEMP2:
	rcall FUNCTION_360_GRD_CHECK_TEMP1_TEMP2
	; Z auf Tabelle				
	ldi ZH, high(TABELLE_SINUS*2)
	ldi ZL,  low(TABELLE_SINUS*2)
	add ZL,temp1			; WINKEL addieren		
	adc ZH,temp2
	add ZL,temp1			; WINKEL addieren		
	adc ZH,temp2
	LPM temp1, Z+  			; aus Tabelle laden		
	LPM temp2, Z+  			; aus Tabelle laden		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
; INP: temp1(LOW),temp2(HIGH)	(WINKEL   0...360)								
; OUT: temp1(LOW),temp2(HIGH) 	(WERT  -127...+127)								
FUNCTION_COSINUS_16_TEMP1_TEMP2:
	rcall FUNCTION_360_GRD_CHECK_TEMP1_TEMP2
	; Z auf Tabelle				
	ldi ZH, high(TABELLE_COSINUS*2)
	ldi ZL,  low(TABELLE_COSINUS*2)
	add ZL,temp1			; WINKEL addieren		
	adc ZH,temp2
	add ZL,temp1			; WINKEL addieren		
	adc ZH,temp2
	LPM temp1, Z+  			; aus Tabelle laden		
	LPM temp2, Z+  			; aus Tabelle laden		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 11/2014															
;																			
;	Value: 0...	4.294.967.295 (0xFFFFFFFF)									
;																			
;	INPUT: 	temp1	(BYTE1)													
;	 		temp2	(BYTE2)													
;			temp3	(BYTE3)													
;			temp4	(BYTE4)													
;																			
;	OUTPUT:	temp1	(		     1-er Stelle)								
;			temp2	(		    10-er Stelle)								
;			temp3	(          100-er Stelle)								
;			temp4	(        1.000-er Stelle)								
;			temp5	(       10.000-er Stelle)								
;			temp6	(      100.000-er Stelle)								
;			temp7	(    1.000.000-er Stelle)								
;			temp8	(   10.000.000-er Stelle)								
;			temp9	(  100.000.000-er Stelle)								
;			temp	(1.000.000.000-er Stelle)								
; 																			
FUNCTION_HEX_ASC_32:
;---------------------------------------------------------------------------
	clr temp			
FUNCTION_HEX_ASC_10:	; 1.000.000.000er Stelle
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNCTION_HEX_ASC_10
	subi temp, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)
;---------------------------------------------------------------------------
	clr temp9			
FUNCTION_HEX_ASC_9:	; 100.000.000er Stelle
	inc temp9
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNCTION_HEX_ASC_9
	subi temp9, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
;---------------------------------------------------------------------------
	clr temp8
FUNCTION_HEX_ASC_8:	; 10.000.000er Stelle
	inc temp8
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNCTION_HEX_ASC_8
	subi temp8, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
;---------------------------------------------------------------------------
	clr temp7
FUNCTION_HEX_ASC_7:	; 1.000.000er Stelle
	inc temp7
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNCTION_HEX_ASC_7
	subi temp7, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
;---------------------------------------------------------------------------
	clr temp6
FUNKTION_HEX_ASC_6:	; 100.000er Stelle
	inc temp6
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_6
	subi temp6, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
;---------------------------------------------------------------------------	clr temp
	clr temp5
FUNCTION_HEX_ASC_5:	; 10.000er Stelle
	inc temp5
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNCTION_HEX_ASC_5
	subi temp5, (-48+1)	; HEX->ASC	
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
;---------------------------------------------------------------------------
	clr temp4
FUNCTION_HEX_ASC_4:	; 1.000er Stelle
	inc temp4
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNCTION_HEX_ASC_4
	subi temp4, (-48+1)	; HEX->ASC	
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
;---------------------------------------------------------------------------
	clr temp3
FUNCTION_HEX_ASC_3:	; 100er Stelle
	inc temp3
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNCTION_HEX_ASC_3
	subi temp3, (-48+1)	; HEX->ASC	
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
;---------------------------------------------------------------------------
	clr temp2
FUNCTION_HEX_ASC_2:	; 10er Stelle
	inc temp2
	subi temp1, low  (10)
	brcc FUNCTION_HEX_ASC_2
	subi temp2, (-48+1)	; HEX->ASC	
	subi temp1, low  (-10)
;---------------------------------------------------------------------------
FUNCTION_HEX_ASC_1:	; 1er Stelle
	subi temp1, -48		; HEX->ASC	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1 (werden nicht gesichert !	)									
; 																						
MULTIPLIKATION_16_8_24:

  	mul temp1,temp3
  	mov temp1,R0
  	mov R2,R1
  	mul temp2,temp3
  	mov temp2,R0
  	add temp2,R2

  	clr temp3 
  	adc temp3,R1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16_32:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	mul	temp4,temp2		; ah * bh
	mov	temp7,r0
	mov	temp8,r1
	mul	temp3,temp1		; al * bl
	mov	temp5,r0
	mov	temp6,r1
	mul	temp4,temp1		; ah * bl
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2
	mul	temp2,temp3		; bh * al
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2


	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	R0,R1,R2 (werden nicht gesichert !	)								
; 					temp5+6+7+8															
FUNKTION_MULTIPLIKATION_16_16_32_SIGNIERT:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	muls temp4, temp2		; (signed)ah * (signed)bh
	mov	temp7, r0
	mov	temp8, r1
	mul	temp3, temp1		; al * bl
	mov	temp5, r0
	mov	temp6, r1
	mulsu	temp4, temp1		; (signed)ah * bl
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2
	mulsu	temp2, temp3		; (signed)bh * al
	sbc	temp8, r2
	add	temp6, r0
	adc	temp7, r1
	adc	temp8, r2

	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl	signiert							
;																				
;	input/Output 	temp1 Divident	(LOW)										
;	input/Output 	temp2 Divident												
;	input/Output 	temp3 Divident												
;	input/Output 	temp4 Divident (HIGH)	signiert							
;																				
;	input			temp5 Divisor	(LOW)	 									
;	input			temp6 Divisor	(HIGH)	signiert							
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister (wird nicht gesichert, wegen Taktersparnis !)	
;																				
FUNCTION_DIVISION_32_16_SIGNIERT:
	clr temp
	; ist Divisor negativ?	
	SBRS temp6,7 			; SPRUNG bei NEGATIV	
	rjmp FUNCTION_DIVISION_32_16_DIVISOR_OK
;-------------------------------------------------------------------------------
	inc temp ; +1 	
	; invertieren (BETRAG bilden)	
	com temp5
	com temp6
	subi temp5, LOW (-1)	; +1	
	sbci temp6, HIGH(-1)
FUNCTION_DIVISION_32_16_DIVISOR_OK:
;-------------------------------------------------------------------------------
	; ist DIVIDENT negativ?
	SBRS temp4,7 			; SPRUNG bei NEGATIV	
	rjmp FUNCTION_DIVISION_32_16_DIVIDENT_OK
;-------------------------------------------------------------------------------
	dec temp ; -1	
	; invertieren (BETRAG bilden)	
	com temp1
	com temp2
	com temp3
	com temp4
	subi temp1, BYTE1(-1)	; +1	
	sbci temp2, BYTE2(-1)
	sbci temp3, BYTE3(-1)
	sbci temp4, BYTE4(-1)
FUNCTION_DIVISION_32_16_DIVIDENT_OK:
;-------------------------------------------------------------------------------
	SBRS temp,0 			; SPRUNG bei BIT-0 gesetzt
	rjmp FUNCTION_DIVISION_32_16	; DIVISION	
;-------------------------------------------------------------------------------
FUNCTION_DIVISION_32_16_DIVIDENT_NEGATIV:
	rcall FUNCTION_DIVISION_32_16	; DIVISION	
	; invertieren (BETRAG bilden)	
	com temp1
	com temp2
	com temp3
	com temp4
	subi temp1, BYTE1(-1)	; +1	
	sbci temp2, BYTE2(-1)
	sbci temp3, BYTE3(-1)
	sbci temp4, BYTE4(-1)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2014																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
FUNCTION_DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne FUNKTION_DIVISION_32_16_RUN
	tst temp6
	brne FUNKTION_DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
FUNKTION_DIVISION_32_16_RUN:
	push R0
	push R1
	push temp
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
FUNKTION_DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    FUNKTION_DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    FUNKTION_DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
FUNKTION_DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
FUNKTION_DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    FUNKTION_DIVISION_32_16_1
	pop temp
	pop R1
	pop R0	
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_NULLSTELLENUNTERDRUECKUNG:
	cpi temp,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp,'_'

	cpi temp9,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp9,'_'

	cpi temp8,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp8,'_'


	cpi temp7,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp7,'_'


	cpi temp6,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp6,'_'

	cpi temp5,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp5,'_'

	cpi temp4,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp4,'_'

	cpi temp3,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp3,'_'

	cpi temp2,'0'
	brne FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG
	ldi temp2,'_'
FUNCTION_NULLSTELLENUNTERDRUECKUNG_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
